% Lab2 NMPDE, 8 maggio 2020
% Problema 1
clear

model=createpde; % oggetto PDEModel
% Q1=(0,1)x(0,1).  parto da (0,0) e proseguo in senso antiorario
Q1=[3,4, 0,1,1,0, 0,0,1,1]';
% C1 cerchio di centro (0.4,0.3) e r=0.2
C1=[1,0.4,0.3,0.2]';
% allungo C1 fino alla lunghezza di Q1
C1=[C1; zeros(length(Q1)-length(C1),1)];
gd=[Q1,C1];
ns=(char('Q1','C1'))';
sf='Q1-C1';
g=decsg(gd,sf,ns);
% importiamo la geometria nel modello
geometryFromEdges(model,g)
% per visualizzare la geometria
pdegplot(model,'Edge','on')

% specifico i coefficienti del problema
specifyCoefficients(model,'m',0,'d',0,'c',1,'a',0,'f',1);

% condizioni al bordo
applyBoundaryCondition(model,...
  'dirichlet','Edge',[1,2],'h',1,'r',1);
applyBoundaryCondition(model,...
  'dirichlet','Edge',5:8,'h',1,'r',0);
applyBoundaryCondition(model,...
  'neumann','Edge',3:4,'q',0,'g',0);

% genero la mesh
generateMesh(model,'Hmax',0.01,'GeometricOrder','quadratic');
pdeplot(model)

% risolvere
results=solvepde(model);

% rappresento la soluzione
figure(1); clf
u=results.NodalSolution;
pdeplot(model,'XYData',u,'Zdata',u,'Mesh','off')
%%
figure(2); clf
[gradx,grady]=evaluateGradient(results);
pdeplot(model,'XYData',u,'Contour','on',...
  'FlowData',[gradx,grady])