% Lab2 NMPDE, 8 maggio 2020
% Problema 2
clear

model=createpde; % oggetto PDEModel
% P1
P1=[2,5,0,1,1.5,0.7,-0.5, 0 0 1 1.5 0.8]';
gd=[P1];
ns=(char('P1'))';
sf='P1';
g=decsg(gd,sf,ns);
% importiamo la geometria nel modello
geometryFromEdges(model,g)
% per visualizzare la geometria
pdegplot(model,'Edge','on')

% specifico i coefficienti del problema
specifyCoefficients(model,'m',0,'d',0,'c',0.1,'a',1,'f',@fcoeff_p2);

% condizioni al bordo
applyBoundaryCondition(model,...
  'dirichlet','Edge',1:5,'h',1,'r',@gd_p2);


% genero la mesh
generateMesh(model,'Hmax',0.05,'GeometricOrder','quadratic');
pdeplot(model);

% risolvere
results=solvepde(model);

% rappresento la soluzione
figure(1); clf
u=results.NodalSolution;
pdeplot(model,'XYData',u,'Zdata',u,'Mesh','off');
%
figure(2); clf
[gradx,grady]=evaluateGradient(results);
pdeplot(model,'XYData',u,'Contour','on',...
  'FlowData',[gradx,grady]);

% calcolo l'errore
uex=@(x,y)exp(x+y); % soluzione esatta
uexx=@(x,y)exp(x+y); % du/dx
uexy=@(x,y)exp(x+y); % du/dy
[errors]=fem_2d_errors(u,model,uex,uexx,uexy)





