% Lab2 NMPDE, 8 maggio 2020
% Problema 3
clear

model=createpde; % oggetto PDEModel
% R1
R1=[3,4, 0,1,1,0, 0,0,1,1]';
C1=[1,0.5,0.5,0.2]';
C1=[C1; zeros(length(R1)-length(C1),1)];
gd=[R1,C1];
ns=(char('R1','C1'))';
sf='C1+R1';
g=decsg(gd,sf,ns);
% importiamo la geometria nel modello
geometryFromEdges(model,g)
% per visualizzare la geometria
pdegplot(model,'Edge','on','FaceLabels','on')

% specifico i coefficienti del problema
specifyCoefficients(model,'m',0,'d',0,'c',1,'a',0,'f',0,'Face',1);
specifyCoefficients(model,'m',0,'d',0,'c',11,'a',0,'f',0,'Face',2);

% condizioni al bordo
applyBoundaryCondition(model,...
  'dirichlet','Edge',4,'u',1);
applyBoundaryCondition(model,...
  'dirichlet','Edge',2,'u',0);
applyBoundaryCondition(model,...
  'neumann','Edge',[1,3],'q',0,'g',0);


% genero la mesh
generateMesh(model,'Hmax',0.05,'GeometricOrder','linear');
pdeplot(model);

% risolvere
results=solvepde(model);

% rappresento la soluzione
figure(1); clf
u=results.NodalSolution;
pdeplot(model,'XYData',u,'Zdata',u,'Mesh','off');
%
figure(2); clf
[gradx,grady]=evaluateGradient(results);
pdeplot(model,'XYData',u,'Contour','on',...
  'FlowData',[gradx,grady]);

 



